<?php

require_once 'ModbusMaster.php';

// Create Modbus object. $a:IP, $b:TCP-UDP, $c:Port, $d:NumberEquip, $e: DirectionHex
// $f: NumberRegisters, $g: Format

function LeerModbus($a,$b,$c,$d,$e,$f,$g){

$modbus = new ModbusMaster($a, $b);
$modbus->port = $c;  
$modbus->client_port = $c;

try {
     
    // read 2 input bits from address 0x0 (Wago input image)
    $recData = $modbus->readInputDiscretes($d, $e, $f); 
     
    switch ($g) {
    	case 1:
      		$values = array_chunk($recData, 4);
       		foreach($values as $bytes)
       		return PhpType::bytes2signedInt($bytes) ;
   	 	case 2:
       		$values = array_chunk($recData, 4);
       		foreach($values as $bytes)
       		return PhpType::bytes2unsignedInt($bytes) ;
    	case 3:
    		$values = array_chunk($recData, 4);
       		foreach($values as $bytes)
       		return PhpType::bytes2float($bytes) ;
    	case 4:
        	$values = array_chunk($recData, 2);
        	foreach($values as $bytes)
        	return PhpType::bytes2signedInt($bytes) ;
    	case 5:
        	$values = array_chunk($recData, 2);
        	foreach($values as $bytes)
        	return PhpType::bytes2unsignedInt($bytes) ;
    	case 6:
         	return PhpType::bytes2string($recData) ;
    	case 7:
        	return $recData;      
}
     
    
}
catch (Exception $z) {
    // Print error information if any
    echo $modbus;
    echo $z;
    exit;
}

}

?>
